/* $Header: /fridge/cvs/cgi.targeted/targeted-cgi.h,v 1.4 2002/07/03 02:19:24 justins Exp $ */
/*
   
   targeted-cgi.h             Copyright(c) 2002-1998 Justin David Smith
   justins(at)chaos2.org      http://chaos2.org/
    
   Utilities for manipulating the CGI arguments
    

   This program is free software; you can redistribute it and/or modify 
   it under the terms of the GNU General Public License as published by 
   the Free Software Foundation, version 2 of the License ONLY.

   This program is distributed in the hope that it will be useful, 
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation, 
   Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#ifndef __targeted_cgi
#define __targeted_cgi


#include <targeted-config.h>


#define  NO_URL      0x00000000
#define  ALL_URLS    0x0000ffff

#define  NORMAL_URL  0x00000001
#define  IMAGE_URL   0x00000002

#define  TYPICAL_URL 0x80000000


bintree *new_cgi_arguments();
bintree *clone_cgi_arguments(const bintree *t);
const char *lookup_cgi_argument(const bintree *t, const char *arg, const char *def);
void set_cgi_argument(bintree *t, const char *arg, const char *val);
void set_cgi_argument_int(bintree *t, const char *arg, int val);
void unset_cgi_argument(bintree *t, const char *arg);
void construct_cgi_url(const config *c, const bintree *t, int urltype, char *buf, int size);

bool is_legal_cgi_url(const bintree *cgi);
bool is_typical_cgi_url(const bintree *cgi);


#endif
