/* $Header: /fridge/cvs/cgi.targeted/targeted-config.h,v 1.10 2002/06/30 19:28:40 justins Exp $ */
/*
   
   targeted-config.h          Copyright(c) 2002-1998 Justin David Smith
   justins(at)chaos2.org      http://chaos2.org/
    
   Script configuration and environment
    

   This program is free software; you can redistribute it and/or modify 
   it under the terms of the GNU General Public License as published by 
   the Free Software Foundation, version 2 of the License ONLY.

   This program is distributed in the hope that it will be useful, 
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation, 
   Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#ifndef __targeted_config
#define __targeted_config


#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <sys/types.h>
#include <dirent.h>
#include <libjstr.h>
#include <libjstra.h>
#include <libjlink.h>
#include <libjcgi.h>


typedef struct config {
   cgi_conf cgi;
   cgi_env  env;
   stringa *cgi_uri;
   stringa *icon_uri;
   stringa *cache_uri;
   stringa *cache_fs;
   stringa *dir_prefix_fs;
   stringa *dir_prefix_uri;
   stringa *header_name;
   stringa *htaccess_name;
   stringa *logfile;
   stringa *css_uri;
   slinknode *admin_ip;
   slinknode *index_names;
   int use_noncgi_url;
   int thumbnail_width;
   int thumbnail_cols;
   int use_toolbox;
} config;


config *get_config(const char *filename);
void free_config(config *c);
void targeted_begin(const config *c, const char *title);
void targeted_end(const config *c);
void targeted_warning(void);


#endif
