/* $Header: /fridge/cvs/cgi.targeted/targeted-util.h,v 1.8 2002/06/30 19:28:40 justins Exp $ */
/*
   
   targeted-util.h            Copyright(c) 2002-1998 Justin David Smith
   justins(at)chaos2.org      http://chaos2.org/
    
   Miscellaneous utilities
    

   This program is free software; you can redistribute it and/or modify 
   it under the terms of the GNU General Public License as published by 
   the Free Software Foundation, version 2 of the License ONLY.

   This program is distributed in the hope that it will be useful, 
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation, 
   Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#ifndef __targeted_util
#define __targeted_util


/* Includes */
#include <targeted.h>
#include <targeted-config.h>


/* Access restrictions */
#define  ACCESS_OK         0
#define  FILE_NOT_FOUND    -1
#define  HTACCESS_DENIES   -2
#define  PERM_DENIES       -3
#define  UNKNOWN_DENIES    -127


/* Functions */
void timer_init(void);
double time_elapsed(void);
bool legal_input(const char *input);
bool is_ascii(const char *input);
void qualify_full_path_file(const config *c, char *dest, int size, const char *r_path, const char *d_name);
void qualify_rel_path_file(const config *c, char *dest, int size, const char *r_path, const char *d_name);
void qualify_full_path(const config *c, char *dest, int size, const char *r_path);
bool compute_parent_directory(char *dest, int size, const char *r_path);
bool validate_directory_name(const char *r_path);
bool validate_file_name(const char *r_path);
bool targeted_index_present(const config *c, const char *r_path);
int targeted_check_access(const config *c, const char *r_path);
stringa *rewrite_directory_name(const char *r_path);
void print_file_size(FILE *f, int size);
bool targeted_admin_ip(const config *c);


#endif /* __targeted_util */
